# Транспорт и логистика - Примеры использования

## Описание
Транспортные и логистические задачи оптимизируют перемещение товаров, планирование маршрутов и управление цепями поставок для минимизации затрат и времени доставки.

## Примеры промптов для LLM

### Пример 1: Классическая транспортная задача
```
Помоги решить транспортную задачу с помощью MCP Optimizer.

У компании есть 3 завода и 4 склада:

Заводы (производство в тоннах):
- Завод А: 300 тонн
- Завод Б: 400 тонн
- Завод В: 500 тонн

Склады (потребность в тоннах):
- Склад 1: 250 тонн
- Склад 2: 350 тонн
- Склад 3: 300 тонн
- Склад 4: 300 тонн

Стоимость доставки (руб/тонна):
От А: [8, 6, 10, 9]
От Б: [9, 12, 13, 7]
От В: [14, 9, 16, 5]

Найди план перевозок с минимальными затратами.
```

### Пример 2: Многопродуктовая логистика
```
Используй MCP Optimizer для оптимизации многопродуктовых поставок.

Компания поставляет 3 вида товаров из 2 распределительных центров в 4 магазина:

Товары: Электроника, Одежда, Продукты

Распределительные центры (запасы):
- РЦ Москва: [500, 800, 1200] единиц
- РЦ СПб: [400, 600, 1000] единиц

Магазины (спрос):
- Магазин 1: [200, 300, 400] единиц
- Магазин 2: [150, 250, 350] единиц
- Магазин 3: [300, 400, 500] единиц
- Магазин 4: [250, 450, 950] единиц

Стоимость доставки по товарам (руб/единица):
Электроника - от Москвы: [15, 18, 12, 20], от СПб: [25, 10, 22, 16]
Одежда - от Москвы: [8, 10, 6, 12], от СПб: [14, 5, 11, 8]
Продукты - от Москвы: [3, 4, 2, 5], от СПб: [6, 2, 4, 3]

Минимизируй общие затраты на логистику.
```

### Пример 3: Планирование цепи поставок
```
Реши задачу планирования цепи поставок с MCP Optimizer.

Сеть поставок включает:
- 2 поставщика сырья
- 3 производственных завода
- 4 распределительных центра
- 5 розничных точек

Поставщики (мощность тонн/месяц):
- Поставщик 1: 1000 тонн
- Поставщик 2: 1500 тонн

Заводы (производительность тонн/месяц):
- Завод А: 800 тонн
- Завод Б: 900 тонн
- Завод В: 700 тонн

Распределительные центры (пропускная способность):
- РЦ 1: 600 тонн
- РЦ 2: 500 тонн
- РЦ 3: 550 тонн
- РЦ 4: 650 тонн

Розничные точки (спрос):
- Магазин 1: 300 тонн
- Магазин 2: 250 тонн
- Магазин 3: 400 тонн
- Магазин 4: 350 тонн
- Магазин 5: 200 тонн

Стоимости перевозок:
Поставщики → Заводы: [[20, 25, 30], [22, 20, 28]]
Заводы → РЦ: [[15, 18, 20, 16], [17, 15, 19, 18], [19, 16, 15, 20]]
РЦ → Магазины: [[10, 12, 8, 11, 14], [11, 9, 10, 13, 12], [13, 11, 9, 10, 15], [12, 14, 11, 9, 13]]

Оптимизируй всю цепь поставок для минимизации общих затрат.
```

### Пример 4: Планирование автопарка
```
Помоги оптимизировать использование автопарка с MCP Optimizer.

Транспортная компания имеет:
- 5 типов грузовиков с разной грузоподъемностью
- 8 маршрутов доставки
- Ограничения по времени и топливу

Типы грузовиков:
- Малый (3 тонны): 10 единиц, расход 12 л/100км, стоимость 800 руб/день
- Средний (5 тонн): 8 единиц, расход 18 л/100км, стоимость 1200 руб/день
- Большой (8 тонн): 6 единиц, расход 25 л/100км, стоимость 1800 руб/день
- Фура (15 тонн): 4 единицы, расход 35 л/100км, стоимость 2500 руб/день
- Мегафура (20 тонн): 2 единицы, расход 40 л/100км, стоимость 3000 руб/день

Маршруты (груз в тоннах, расстояние в км):
- Маршрут 1: 12 тонн, 150 км
- Маршрут 2: 8 тонн, 200 км
- Маршрут 3: 25 тонн, 300 км
- Маршрут 4: 6 тонн, 100 км
- Маршрут 5: 18 тонн, 250 км
- Маршрут 6: 4 тонн, 80 км
- Маршрут 7: 30 тонн, 400 км
- Маршрут 8: 15 тонн, 180 км

Цена топлива: 55 руб/литр

Найди оптимальное назначение грузовиков на маршруты для минимизации общих затрат.
```

### Пример 5: Складская логистика
```
Оптимизируй складские операции с помощью MCP Optimizer.

Распределительный центр обрабатывает заказы для интернет-магазина:

Зоны склада:
- Зона А (электроника): 500 м², стоимость хранения 100 руб/м²/день
- Зона Б (одежда): 800 м², стоимость хранения 60 руб/м²/день
- Зона В (продукты): 600 м², стоимость хранения 80 руб/м²/день
- Зона Г (мебель): 400 м², стоимость хранения 120 руб/м²/день

Товарные группы (объем м³, требуемая площадь м²):
- Смартфоны: 200 м³, 150 м²
- Ноутбуки: 300 м³, 200 м²
- Куртки: 400 м³, 300 м²
- Обувь: 350 м³, 250 м²
- Консервы: 500 м³, 200 м²
- Напитки: 600 м³, 300 м²
- Столы: 250 м³, 180 м²
- Стулья: 300 м³, 220 м²

Ограничения совместимости:
- Продукты нельзя хранить с электроникой
- Мебель требует отдельную зону
- Одежда совместима с любыми товарами

Минимизируй затраты на хранение при соблюдении всех ограничений.
```

### Пример 6: Международная логистика
```
Реши задачу международных поставок с MCP Optimizer.

Глобальная компания поставляет товары из 3 стран-производителей в 6 стран-потребителей:

Страны-производители (мощность тыс. единиц/месяц):
- Китай: 5000 единиц
- Германия: 3000 единиц
- США: 4000 единиц

Страны-потребители (спрос тыс. единиц/месяц):
- Россия: 1500 единиц
- Бразилия: 2000 единиц
- Индия: 2500 единиц
- Франция: 1800 единиц
- Япония: 2200 единиц
- Австралия: 1000 единиц

Стоимость доставки (долл/единица):
Из Китая: [8, 15, 6, 12, 4, 10]
Из Германии: [12, 18, 14, 3, 11, 16]
Из США: [14, 8, 16, 9, 13, 12]

Таможенные пошлины (%):
В Россию: [5, 8, 12]
В Бразилию: [10, 6, 15]
В Индию: [8, 12, 10]
Во Францию: [3, 0, 7]
В Японию: [6, 4, 8]
В Австралию: [7, 5, 9]

Время доставки (дни):
Из Китая: [25, 35, 20, 30, 10, 15]
Из Германии: [20, 40, 25, 5, 15, 30]
Из США: [30, 15, 35, 10, 20, 25]

Оптимизируй поставки с учетом затрат, пошлин и времени доставки.
```

### Пример 7: Городская логистика последней мили
```
Оптимизируй доставку последней мили с MCP Optimizer.

Служба доставки обслуживает город с 50 точками доставки:

Депо: Центральный склад (координаты 0, 0)

Курьеры:
- 10 пеших курьеров (радиус 3 км, 8 заказов/день, 500 руб/день)
- 8 велокурьеров (радиус 8 км, 15 заказов/день, 800 руб/день)
- 6 мотокурьеров (радиус 15 км, 25 заказов/день, 1200 руб/день)
- 4 автокурьера (радиус 25 км, 40 заказов/день, 2000 руб/день)

Заказы по районам:
- Центр (0-5 км): 120 заказов, приоритет высокий
- Средний (5-12 км): 180 заказов, приоритет средний
- Окраины (12-20 км): 100 заказов, приоритет низкий
- Пригород (20+ км): 50 заказов, приоритет низкий

Временные окна доставки:
- Утро (9-12): 30% заказов
- День (12-15): 40% заказов
- Вечер (15-18): 30% заказов

Штрафы за опоздание:
- Высокий приоритет: 200 руб/заказ
- Средний приоритет: 100 руб/заказ
- Низкий приоритет: 50 руб/заказ

Найди оптимальное распределение курьеров и маршрутов.
```

### Пример 8: Оптимизация железнодорожных перевозок
```
Помоги оптимизировать железнодорожные грузоперевозки с MCP Optimizer.

Железнодорожная компания перевозит грузы между 8 городами:

Города: Москва, СПб, Екатеринбург, Новосибирск, Казань, Ростов, Краснодар, Владивосток

Типы вагонов:
- Крытые (40 тонн): 200 вагонов, 1500 руб/сутки
- Платформы (60 тонн): 150 вагонов, 2000 руб/сутки
- Цистерны (50 тонн): 100 вагонов, 1800 руб/сутки
- Хопперы (70 тонн): 80 вагонов, 2200 руб/сутки

Грузопотоки (тонн/неделя):
- Москва → СПб: 2000 (контейнеры)
- Екатеринбург → Москва: 3000 (металл)
- Новосибирск → СПб: 1500 (зерно)
- Казань → Краснодар: 1000 (химия)
- Ростов → Москва: 2500 (продукты)
- Владивосток → Москва: 1800 (контейнеры)

Расстояния между городами (км):
Матрица расстояний 8x8 с реальными железнодорожными расстояниями

Время в пути (дни):
- До 1000 км: 2 дня
- 1000-2000 км: 4 дня
- 2000-4000 км: 7 дней
- Более 4000 км: 10 дней

Ограничения:
- Контейнеры только в крытых вагонах
- Металл только на платформах
- Зерно только в хопперах
- Химия только в цистернах

Минимизируй общие затраты на перевозку с учетом времени доставки.
```

## Структура запроса к MCP Optimizer

```python
# Пример для транспортной задачи
result = solve_transportation_problem(
    supply=[300, 400, 500],  # предложение
    demand=[250, 350, 300, 300],  # спрос
    costs=[
        [8, 6, 10, 9],
        [9, 12, 13, 7],
        [14, 9, 16, 5]
    ]
)
```

## Типичные фразы для активации

- "Реши транспортную задачу"
- "Оптимизируй логистику доставки"
- "Найди оптимальные маршруты перевозок"
- "Минимизируй затраты на транспорт"
- "Спланируй цепь поставок"
- "Оптимизируй работу автопарка"
- "Помоги с планированием складских операций"

## Применение

Транспортные и логистические задачи используются в:
- Грузоперевозках и логистике
- Планировании цепей поставок
- Управлении складскими операциями
- Оптимизации автопарков
- Международной торговле
- Городской логистике
- Железнодорожных перевозках 